package benchmark;

import java.util.List;
import java.util.LinkedList;

public class Driver {

    private Option master_option;
    private List<Option> optionq;
    private List<Option> past_option;
    private List<Metric> past_metric;

    public Driver(Option option) {
        master_option = option;
        optionq = new LinkedList<Option>();
        past_option = new LinkedList<Option>();
        past_metric = new LinkedList<Metric>();
    }

    public boolean enqueueOption(Option option) {
        return optionq.add(option);
    }

    public Option dequeueOption() {
        if (optionq.isEmpty()) {
            return null;
        } else {
            return optionq.remove(0);
        }
    }

    // Example of filling the option queue.
    public void fillWithCetusOptions() {
        Option option = master_option.clone();
        option.set("cetus", "option", "induction=1");
        enqueueOption(option);
        option = master_option.clone();
        option.set("cetus", "option", "inline=1");
        enqueueOption(option);
    }

    public void record(Option option, Metric metric) {
        past_option.add(option);
        past_metric.add(metric);
    }

    public String toString() {
        String ret = "MASTER OPTION:\n" + master_option;
        for (int i = 0; i < past_option.size(); i++) {
            ret += "\n" + "OPTION " + i + ":\n" + past_option.get(i);
            ret += "\n" + "METRIC " + i + ":\n" + past_metric.get(i);
        }
        return ret;
    }

}
